create or replace package body LOGGER is

 g_loglevel_threshold varchar2(20):= 'info'; -- any message with a lower level than this threshold is not written
 g_file_writer        varchar2(120);
 
 type hashmap is table of number(1) index by varchar2(15);
 g_log_levels hashmap;
 
 procedure log_message
  ( p_log_level in varchar2
  , p_log_origin in varchar2
  , p_log_message in varchar2
  ) is
  begin
    if g_log_levels( p_log_level) >= g_log_levels(g_loglevel_threshold)
    then
      dbms_output.put_line( substr(p_log_origin||': '||p_log_message, 1,255));
    end if;
  end log_message;

  procedure set_loglevel_threshold
  ( p_log_level in varchar2
  ) is
  begin
    g_loglevel_threshold:= p_log_level;
  end set_loglevel_threshold;
  
  procedure set_file_writer
  ( p_file_writer in varchar2
  ) is
  begin
    g_file_writer:= p_file_writer;
  end set_file_writer;
  
begin
  g_log_levels('fine'):= 0;
  g_log_levels('debug'):= 1;
  g_log_levels('info'):= 2;
  g_log_levels('warning'):= 3;
  g_log_levels('error'):= 4;
  g_log_levels('fatal'):= 5;
end LOGGER;
